#include "memcard/country_code.hpp"

namespace mc::psx {
std::string to_string (CountryCode code) {
	switch (code) {
	case CountryCode::Japan: return "Japan";
	case CountryCode::America: return "America";
	case CountryCode::Europe: return "Europe";
	default: return "Unknown";
	};
}

char to_char (CountryCode code) {
	switch (code) {
	case CountryCode::Japan: return 'J';
	case CountryCode::America: return 'U';
	case CountryCode::Europe: return 'E';
	default: return 'X';
	};
}

uint16_t to_uint16 (CountryCode code) {
	return static_cast<uint16_t>(code);
}

CountryCode to_country_code (uint16_t code) {
	switch (code) {
	case static_cast<uint16_t>(CountryCode::Japan): return CountryCode::Japan;
	case static_cast<uint16_t>(CountryCode::America): return CountryCode::America;
	case static_cast<uint16_t>(CountryCode::Europe): return CountryCode::Europe;
	default: return CountryCode::Unknown;
	}
}
} //namespace mc::psx
