#include "memcard/frame.hpp"
#include <cassert>

namespace mc::psx {
template <bool Const>
BasicFrame<Const>::BasicFrame (data_type* data, std::size_t index) :
	m_index(index),
	m_data(data)
{
}

template <bool Const>
auto BasicFrame<Const>::operator[] (std::size_t index) -> data_type& {
	assert(index < size());
	return m_data[index];
}

template <bool Const>
auto BasicFrame<Const>::operator[] (std::size_t index) const -> const data_type& {
	assert(index < size());
	return m_data[index];
}

template class BasicFrame<true>;
template class BasicFrame<false>;
} //namespace mc::psx
